;
;This file is part of ZXSpectr.
;
;ZXSpectr is free software; you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation; either version 2 of the License, or
;(at your option) any later version.

;ZXSpectr is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with ZXSpectr; if not, write to the Free Software
;Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

;Rutinas de control del sonido para Sound Blaster.

PUBLIC soundblaster_presente,out211_blaster

soundblaster_presente	 db	0 ;A 1 si se detecta sound blaster

;Puertos de la Sound Blaster
puerto_sb				dw		?
irq_sb					db		?
dma_ch               db		?

dsp_reset				dw		06h
dsp_read_data  		dw    0ah
dsp_write				dw		0ch
dsp_data_available	dw		0eh
ct_index					dw		04h
ct_data					dw    05h
pic_or_mask				db		?
pic_and_mask				db		?

dma_page					db		?
dma_address				db		?
dma_lenght				db		?

;Puertos de la Sound Blaster


CANAL_IZQ				equ	0220h
CANAL_DER				equ	0222h
CANAL_CEN				equ	0388h

adlib_address			dw		CANAL_CEN

;Reproduccion del sonido
FRAMES_BUFFER			equ	15 ;frames de pantalla que ocupa el buffer de audio
;El maximo buffer es 312*25*2

seg_buffer_blaster	dw		?	;segmento del buffer de reproduccion del sonido
puntero_buffer_blaster	dw 	0 ;posicion del puntero dentro del buffer de audio
frames_audio_actual	db		FRAMES_BUFFER	;frames que quedan para llenar el buffer
;cuando se llega a 0, enviar el sonido (o enviarlo cuando llegue la IRQ? )
blaster_old_irq			dd		?
temp_dma_play			dw		?

;Inicialmente, mono
puerto_canal_a       dw    CANAL_CEN
puerto_canal_b       dw    CANAL_CEN
puerto_canal_c			dw		CANAL_CEN
last_speaker_value	db		0 ;Ultimo valor enviado al pcspeaker (0 o 255)

;En la emulacion del chip de sonido, si hay ruido, este siempre sale
;por el centro, ya que se usa un solo canal para cualquiera de los tres


men_si_blaster  		db		"Sound Blaster detectada A2$"
men_si_blaster2 		db    "0 I$"
men_si_blaster3		db		" D$"
men_si_blaster4      db		10,13,"$"

men_no_blaster 		db		"Sound Blaster no detectada",10,13
							db		"$"

cadena_blaster			db		"BLASTER=",0
							
inicializar_soundblaster:

					;Si se especifica el parametro /nosb, no inicializarla
					test	parametros_flags,00000100b

					jz		inicializar_soundblaster2
					ret

inicializar_soundblaster2:

					;Detectar puerto de la Sound Blaster
					;Leerlo de las variables del entorno

					xor	di,di
					mov	ax,word ptr cs:[2ch]
					mov	es,ax
					mov     cx,65535
					cld

inicio_SB_bucle:					
					mov	si,offset cadena_blaster
					repz  cmpsb
					cmp	byte ptr [si-1],0
					jz		inicio_SB_bucle_si
					cmp	byte ptr es:[di-1],0
					jnz  	inicio_SB_bucle

					;Ver si hay otro cero. En ese caso, no hay variable
					cmp	byte ptr es:[di],0
					jz    inicio_SB_no
					jmp     short inicio_SB_bucle

inicio_SB_bucle_si:
					;Esta la variable. Detectar puerto, irq, dma
					;Formato variable: BLASTER=A2x0 Iy Dz
					;Leer puerto: Solo la x

					mov   al,byte ptr es:[di+1]
					sub	al,'0'
					mov	cl,4
					shl   al,cl
					mov	ah,2
					mov	puerto_sb,ax

					mov   al,byte ptr es:[di+5]
					sub	al,'0'
					mov	irq_sb,al
					
					;Poner mascara PIC
					mov	cl,al
					inc	cl
					mov	al,10000000b ; bit 0 a 1 = IRQ 0
					
					rol	al,cl
					mov	pic_or_mask,al
					
					not	al
					mov	pic_and_mask,al
					

					mov   al,byte ptr es:[di+8]
					sub	al,'0'
					mov	dma_ch,al

					;Mirar si se inicializa bien

					mov	dx,puerto_sb
					add	dx,6


					cli

					mov	al,1
					out   dx,al
					mov	cx,0
inicio_SB:		loop	inicio_SB ;Pausa
					xor	al,al
					out	dx,al



inicio_SB2:		loop	inicio_SB2 ;Pausa

					add	dx,0eh-06h

					in		al,dx

					and	al,080h
					jz		inicio_SB_no
					sub	dx,0eh-0ah

					in		al,dx

					cmp	al,0aah
					jz		inicio_SB_si

inicio_SB_no:
					sti
					mov	soundblaster_presente,0
					mov	ah,9
					mov	dx,offset men_no_blaster
					int	21h

					ret


inicio_SB_si:	mov	soundblaster_presente,1
					or		bits_estado3,00001000b ;Sonido altavoz a traves Sblaster

					;Inicializar valores puertos Sound Blaster
					mov	ax,puerto_sb
					add   dsp_reset,ax
					add   dsp_read_data,ax
					add	dsp_write,ax
					add   dsp_data_available,ax
					add	ct_index,ax
					add	ct_data,ax

					;Inicializar valores control DMA
					mov   al,dma_ch
					mov	ah,al
					add	al,al
					mov	dma_address,al
					inc	al
					mov	dma_lenght,al
					or		ah,ah
					jnz	inicio_DMAno0
					mov	dma_page,87h
					jmp	short inicio_DMAsigue
inicio_DMAno0:
					cmp	ah,1
					jnz	inicio_DMAno1
					mov	dma_page,83h
					jmp	short inicio_DMAsigue

inicio_DMAno1:
					cmp	ah,2
					jnz	inicio_DMAno2
					mov	dma_page,81h
					jmp	short inicio_DMAsigue

inicio_DMAno2:
					mov	dma_page,82h
inicio_DMAsigue:

					
					

														
					;Reset Mixer
					xor	ax,ax
					call	write_ct

					;Selecccionar Output en Estereo
					mov	ah,0eh
					mov	al,00100010b  ;Bypass O/P Filter
					call	write_ct

					;Selecccionar Volumen Maximo (Master)
					mov	ah,22h
					mov	al,255
					call	write_ct
					
					;Selecccionar Volumen Maximo (DSP)
					mov	ah,04h
					mov	al,255
					call	write_ct
					
					;Seleccion de Linea
					mov	ah,0ch
					mov	al,00000110b
					call	write_ct
COMMENT !
					  Input Setting Register (0Ch):
	 ADC - input source:
	 d[2] d[1]
		0    0    Microphone (default)
		0    1    CD audio
		1    0    Microphone
		1    1    Line-in
	 In Filter - filter select:
	 d[5] d[4] d[3]
		0    x    0   Low Filter (default)
		0    x    1   High Filter
		1    x    x   No Filter
!

					;Volumen 15 de Linea(izq. y der.)
					mov	ah,2eh
					mov	al,255
					call	write_ct
					
					;Activar altavoz
					mov	al,0d1h
					call  write_dsp


					mov 	dx,offset int_irq_blaster
					call	inicializa_int_irq
;Cambia vector de interrupcion IRQ
;Entrada: DX=Direccion gestor interrupcion

					sti

					mov	ah,9
					mov	dx,offset men_si_blaster
					int	21h


					mov	dl,byte ptr puerto_sb
					mov	cl,4
					shr	dl,cl
					add	dl,'0'
					mov	ah,2
					int	21h

					mov	ah,9
					mov	dx,offset men_si_blaster2
					int	21h

					mov	dl,irq_sb
					add	dl,'0'
					mov	ah,2
					int	21h

					mov	ah,9
					mov	dx,offset men_si_blaster3
					int	21h

					mov	dl,dma_ch
					add	dl,'0'
					mov	ah,2
					int	21h

					mov	ah,9
					mov	dx,offset men_si_blaster4
					int	21h


					ret

out211_blaster: ;Sonido de puerto Sound Blaster a traves Speaker
					cmp	ah,2
					jnz	out211_blaster2
					mov   ah,0

					jmp	short out211_blaster3
out211_blaster2:
					mov   ah,255

out211_blaster3:
      			mov	last_speaker_value,ah
      			ret
      	

write_dsp:		;Llama a espera_dsp y escribe valor AL.
					mov	cl,al
					call  espera_dsp
					mov	al,cl
					out	dx,al
					ret


write_ct:		;Escribe en el CT_Mixer , indice AH y valor AL
					mov	dx,ct_index
					xchg	al,ah
					out	dx,al

					mov	dx,ct_data
					xchg	al,ah
					out	dx,al
					ret

read_ct:		   ;Lee del CT_Mixer , indice AL y devuelve en AL
					mov	dx,ct_index
					out	dx,al

					mov	dx,ct_data
					in		al,dx
					ret




espera_dsp:    ;Esperar a poder escribir en DSP. Devuelve en dx=dsp_write
					mov	dx,dsp_write
espera_dsp2:
					in		al,dx
					shl	al,1
					jc    espera_dsp2
					ret
					
COMMENT !

read_adlib:  	;Lee en AL registro AH
					mov   dx,adlib_address
					xchg	al,ah
					out   dx,al
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					inc   dx
					xchg	al,ah
					in    al,dx
					ret
!
COMMENT !


write_adlib:	;Escribe en registro AH valor AL
					;Mirar si no esta la emulacion de ruido
					test	bits_estado7,00000100b
					jz		write_adlib0

					;No hacer registros A7,B7,54
					cmp   ah,0a7h
					jz    write_adlib_fin
					cmp   ah,0b7h
					jz		write_adlib_fin
					cmp   ah,054h
					jnz	write_adlib0


write_adlib_fin:
					ret

write_adlib0:
					mov   dx,adlib_address
					xchg	al,ah
					out   dx,al
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					inc   dx
					xchg	al,ah
					out   dx,al
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx
					in    al,dx

					ret
!

;inicializa_adlib:	;Inicializa ADLIB, los tres (izq,der,centro)
;					mov	adlib_address,CANAL_IZQ
;					call	inicializa_adlib0
;					mov	adlib_address,CANAL_DER
;					call	inicializa_adlib0
;					mov	adlib_address,CANAL_CEN
;					call	inicializa_adlib0
;              ret

COMMENT !

inicializa_adlib0:

					xor	al,al
					mov	ah,0
					mov	cx,255
					call	reset_adlib_bucle

					;Inicializar valores registros ADLIB
					mov	bx,offset t_inicio_sblaster
inicializa_adlib_buc:
					mov	ah,byte ptr [bx]
					cmp	ah,0ffh
					jz    inicializa_adlib_buc_sigue
					mov	al,byte ptr [bx+1]
					inc	bx
					inc	bx
					push	bx
					call	write_adlib
					pop	bx
					jmp	short inicializa_adlib_buc

inicializa_adlib_buc_sigue:

					mov	cl,0
inicializa_adlib_buc2:
					;Inicializar valores registros ADLIB
					mov	bx,offset t_inicio_sblaster2
inicializa_adlib_buc3:
					mov	ah,byte ptr [bx]
					cmp	ah,0ffh
					jz    inicializa_adlib_buc3_sigue
					add	ah,cl
					mov	al,byte ptr [bx+1]

					inc	bx
					inc	bx
					push	bx
					push	cx
					call	write_adlib
					pop	cx
					pop	bx
					jmp	short inicializa_adlib_buc3
inicializa_adlib_buc3_sigue:
					inc	cl
					cmp	cl,3
					jnz   inicializa_adlib_buc2

					ret
!

COMMENT !


reset_adlib_bucle:  ;Subrutina de reset_adlib
					push	ax
					push	cx
					call	write_adlib
					pop	cx
					pop	ax
					inc	ah
					loop	reset_adlib_bucle
					ret
					
!

inicializa_int_irq:

					push	es
;Cambia vector de interrupcion IRQ
;Entrada: DX=Direccion gestor interrupcion
					;Calcular direccion de memoria
					mov	bl,irq_sb
					add   bl,8  ;irq 0 -> int 8
					xor	bh,bh
					;Multiplicar *4
					add	bx,bx
					add	bx,bx

					xor	ax,ax
					mov	es,ax
					mov	ax,word ptr es:[bx]
					mov	word ptr old_irq,ax
					mov	ax,word ptr es:[bx+2]
					mov	word ptr old_irq+2,ax
					;mov	ax,offset int_irq
					mov	word ptr es:[bx],dx
					mov	ax,cs
					mov	word ptr es:[bx+2],ax
					pop	es
					
				           ; CHANGE PIC MASK :
           in      al,021h
           and     al,pic_and_mask   ; CLEAR MASK REGISTER BIT TO ENABLE INTERRUPT
           out     021h,al
	

					ret

restaura_int_irq:
					push	es
;Restaura vector de interrupcion IRQ
					;Calcular direccion de memoria
					mov	bl,irq_sb
					add   bl,8  ;irq 0 -> int 8
					xor	bh,bh
					;Multiplicar *4
					add	bx,bx
					add	bx,bx

					xor	ax,ax
					mov	es,ax

					mov	ax,word ptr old_irq
					mov	word ptr es:[bx],ax

					mov	ax,word ptr old_irq+2
					mov	word ptr es:[bx+2],ax

					pop	es
					
					

					ret


pon_modo_stereo:
;Aqui pone los canales que corresponden (izq,der,cent) segun el
;modo Mono,ACB o ABC
					mov	al,bits_estado7
					and	al,3
					jnz	pon_modo_stereo_no0
					mov	puerto_canal_a,CANAL_CEN
					mov	puerto_canal_b,CANAL_CEN
					mov	puerto_canal_c,CANAL_CEN
					ret
pon_modo_stereo_no0:
					cmp	al,1
					jnz	pon_modo_stereo2
					mov	puerto_canal_a,CANAL_IZQ
					mov	puerto_canal_b,CANAL_DER
					mov	puerto_canal_c,CANAL_CEN
					ret

pon_modo_stereo2:
					mov	puerto_canal_a,CANAL_IZQ
					mov	puerto_canal_b,CANAL_CEN
					mov	puerto_canal_c,CANAL_DER
					ret

COMMENT !
t_inicio_sblaster  db 01h,020h
					db		0bdh,020h+8


					db		034h,021h
					db		054h,03fh

					db		074h,099h

					db		094h,0

					db		0f4h,0

					db		0bdh,028h



					db		0ffh

t_inicio_sblaster2	db		020h,01h
					db		023h,01h

					db		040h,018h
					db		043h,03fh

					db		060h,0f0h
					db		063h,0f0h

					db		080h,014h
					db    083h,013h

					db		0e0h,02h
					db		0e3h,00h

					db		0c0h,0ah
					db		0b0h,00
					db		0ffh
!

int_irq_blaster:
					push	ax
					push	bx
					push	cx
					push	dx

					push	ds

					push	cs
					pop	ds
					
					;
					;push	es
					;mov	ax,seg_vga
					;mov	es,ax
					;mov	byte ptr es:[00],3
					;pop	es
					;

					mov	dx,dsp_data_available
					in		al,dx
					
					mov	al,32
					out	32,al
					

					call	write_blaster_sound
					
					xor	seg_blaster,1 ;cambiar bloque
					
					;mov	al,32
					;out	32,al
					
					pop	ds

					pop	dx
					pop	cx
					pop	bx
					pop	ax
					nop
					nop
					iret
					
inicializa_dma_play:

					mov	ax,FRAMES_BUFFER*2 ;
					mov	bx,sync_lineas
					
					mul	bx
	
					mov	temp_dma_play,ax

					mov	al,dma_ch
					add	al,4
					out	0ah,al

					xor	al,al
					out	0ch,al

					mov	al,dma_ch
					add	al,48h ;49h ;49=play
					out	0bh,al


					;mov	ax,seg_buffer_blaster
					call	da_seg_blaster

					xor	bl,bl

					shl	ax,1 ;Poner en BL los 4 bits altos de AH
					rcl   bl,1
					shl	ax,1
					rcl   bl,1
					shl	ax,1
					rcl   bl,1
					shl	ax,1
					rcl   bl,1

					mov	dl,dma_address
					xor	dh,dh
					out	dx,al


					mov	al,ah

					out	dx,al


;					mov	dl,dma_page
;					xor	dh,dh
;					mov	al,bl
;					out	dx,al


					mov	dl,dma_lenght
					xor	dh,dh
					mov	ax,temp_dma_play
	
					dec	ax      ;Hay que decir 1 byte menos

					out	dx,al

					mov	al,ah
					out	dx,al

               mov   dl,dma_page
               xor   dh,dh
               mov   al,bl
               out   dx,al

					mov	al,dma_ch
					out	0ah,al
					
					ret
					
					
inicializa_dsp_play:


					mov	al,40h
					call	write_dsp
					
					mov	ax,50*2 ;Frecuencia siempre sync_lineas*50*2
					mov	bx,sync_lineas
					mul	bx

;Esta funcion calcula la frecuencia que se le enviara a la Sound Blaster
;Se calcula:
;  frecuencia real=256-1000 000L/frecuencia
;Entrada: AX=frecuencia
;Salida: AL=frecuencia real
	
					;mov	ax,22050
					call	calcula_frecuencia_real
					;sub 	al,2

					call	write_dsp
					
					mov	ax,FRAMES_BUFFER*2 ;
					mov	bx,sync_lineas
					
					mul	bx
					
					mov	al,14h ;8 bits
					call	write_dsp

					dec	ax      ;Hay que decir 1 byte menos
					push	ax

					call	write_dsp

					pop	ax

					mov	al,ah

					call	write_dsp
					
					;Activar altavoz
					mov	al,0d1h
					call  write_dsp
					
					;DMA Continue
					;mov	al,0d4h  ;es necesario aqui ???
					;call  write_dsp
					

					ret
					

					
primera_vez		db		0		
seg_blaster		db		0 ;buffer usado

da_seg_blaster:
					cmp	seg_blaster,0
;;Devuelve AX=seg_buffer_sonido si Z o AX=seg_buffer_sonido+1024 si NZ
					mov	ax,seg_buffer_blaster
					
					ret
					
					jz              da_seg_blaster2
					add	ax,312*25*2/16  ;16384/16
da_seg_blaster2:
					ret
			
write_blaster_sound0:
					;Solo se llama una vez, las siguientes, se llamara desde la irq
					cmp	primera_vez,0
					mov	primera_vez,1
					jz		write_blaster_sound
					ret

write_blaster_sound:
					cmp	soundblaster_presente,1
					jz		write_blaster_sound2
					ret
					
write_blaster_sound2:
	
					push	ax

					push	dx
					
					;call	inicializa_dsp_play
					;call	inicializa_dma_play
					
					cli

					call	inicializa_dma_play
					call	inicializa_dsp_play
					
					;FIN
					
;					mov	frames_audio_actual,FRAMES_BUFFER
;					mov	puntero_buffer_blaster,0
					
					pop	dx

					pop	ax
					
					sti
					
					ret
					
incrementa_puntero_blaster:					
					cmp	soundblaster_presente,1
					jz		incrementa_puntero_blaster2
					ret
					
incrementa_puntero_blaster2:				
					;Ponerlo en el buffer de sonido

					push	es
					push	bx
					push	ax
					
					;mov 	es,seg_buffer_blaster
					call	da_seg_blaster
					mov	es,ax
					
					mov	bx,puntero_buffer_blaster
					mov	ah,last_speaker_value
					mov	es:[bx],ah
					mov	es:[bx+1],ah  ;Se pone dos veces porque es estereo
				
					pop	ax
					pop	bx	
					pop	es
					
					inc	puntero_buffer_blaster
					inc	puntero_buffer_blaster
					
				
					ret
					
